

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <errno.h>
#include <ctype.h>

#include "words.h"
#include "rooms.h"
#include "player.h"
#include "input.h"

#ifdef __CBM__
#include "simpleio.h"
#elif defined __ATARI__
#include "atasimpleio.h"
#include "atadisk65.h"
#endif


#ifdef __USEFARMEM__
#ifdef __C64__
#include "c64hide.h"
#elif defined __C128__
#include "membank128.h"
#define hidereadb bank1_readbyte
#define hidereadw bank1_readword
#define printh bank1_print
#elif defined __APPLE2ENH__

#elif defined __ATARI__
#include "memxatari.h"
#define hidereadb aux_readbyte
#define hidereadw aux_readword
#define printh aux_print
#endif
#else
#define hidereadb
#define hidereadw
#endif

int hideloadfile2 (void);

struct player_ Player;
//#pragma bss-name (push, "BAS1BSS")
//#pragma bss-name (push, "V2BSS")

#ifdef __C128__
#ifdef __USEFARMEM__
#pragma bss-name (push, "B1BSS")
#else 
#pragma bss-name (push, "APPBSS")
#endif
#elif defined __C64__
#pragma bss-name (push, "V2BSS")
#elif defined __PLUS4__
#pragma bss-name (push, "BSS")
#elif defined __ATARI__
#pragma bss-name (push, "BSS")
#endif

short Num;
//#pragma bss-name (push, "Z2BSS")

//Current room #.
extern unsigned char CRoom;
#pragma zpsym ("CRoom")

//Temp. variables.
extern unsigned char i, j;
#pragma zpsym ("i")
#pragma zpsym ("j")

//Current varb #.
extern unsigned char Vrb;
#pragma zpsym ("Vrb")

//Current pos. in user input string.
extern unsigned char CurPos;
#pragma zpsym ("CurPos")

//Temp. variables.
extern unsigned char c;
#pragma zpsym ("c")

extern unsigned char *s;
#pragma zpsym ("s")

//Pointer to current room data.
extern struct room* CRm;
#pragma zpsym ("CRm")

//Middleman to look w/out item.
void vLook2 (void);

//Middleman to print a period folowed by a CR.
void __fastcall__ printperiod (void);

//Array to hold user input.
#ifdef __C128__
char Input [78];
#elif defined __C64__
#pragma bss-name (pop)
char Input [38];
//#pragma bss-name (push, "V2BSS")

#pragma bss-name (push, "V2BSS")
#else
char Input [38];

#endif
//Routine to load the stubs on CBM machines.
//fi[] holds the name of the first stub, and, before
//function exit, the number is incremented.
#ifdef __CBM__
#ifdef __C64__
static char fi[]="stub1";
void __fastcall__ load2 (void)
#elif defined __PLUS4__
#pragma code-name (push, "LOWCODE")
#pragma data-name (push, "LOWCODE")
static char fi[]="adv-low1";

void __fastcall__ load2 (void)
#elif defined __C128__
static char fi[]="lowmem1";

void __fastcall__ load2 (void)
#endif
{
//#ifdef __C128__
//	//printscr (fi);
//	cbm_load (fi, 8, 0);
//#else
	//cbm_k_setlfs(0, 8, 1);
	__asm__ (
#ifdef __PLUS4__
		"\tsta\t$FF3F\n"
#elif defined __C128__
		"\tsta\t$FF03\n"
#endif
		"\tlda\t#0\n"
		"\tldx\t#8\n"
		"\tldy\t#1\n"
		"\tjsr\tSETLFS\n"
#ifdef __C64__
		"\tlda\t#5\n"
#elif defined __C128__
		"\tlda\t#7\n"
#elif defined __PLUS4__
		"\tlda\t#8\n"
#endif
		"\tldx\t#<_fi\n"
		"\tldy\t#>_fi\n"
		"\tjsr\tSETNAM\n"
		"\tlda\t#0\n"
		"\ttax\n"
		"\ttay\n"
		"\tjsr\tLOAD\n"
#ifdef __PLUS4__
		"\tsta\t$FF3E\n"
#elif defined __C128__
		"\tsta\t$FF01\n"
#endif
		);
	//cbm_k_load(0, 0);
//#endif
#ifdef __C64__
	++fi[4];
#elif defined __PLUS4__
	//fi[7]=t;
	++fi[7];
#elif defined __C128__
	++fi[6];
#endif
}

//static char l2[]="stub1";

#ifdef __C128__
#pragma code-name (push, "APPCODE")
#endif
#ifdef __PLUS4__
#pragma data-name (pop)
#pragma code-name ("TAPECODE")
#endif

//Routines to load and save gamw on CBM computers.
//Pass the filename in c.
void loadgame (char* c)
{
	cbm_open (1, 8, CBM_READ, c);
	cbm_read (1, &Player, sizeof (Player));
	cbm_close (1);
}

void savegame (char* c)
{
	cbm_open (1, 8, CBM_WRITE, c);
	cbm_write (1, &Player, sizeof (Player));
	cbm_close (1);
}

#ifdef __C128__
//#pragma code-name (push, "APPCODE")
#elif defined __C64__
#pragma code-name (push, "BAS2CODE")
#elif defined __ATARI__
#pragma code-name (push, "MBUFCODE")
#endif

#ifdef __PLUS4__
#pragma code-name ("BASBCODE")
#endif
#pragma code-name (pop)
#endif

#ifdef __ATARI__
#pragma code-name (push, "TBUFCODE")
#endif

#ifdef __PLUS4__
#pragma code-name (push, "TAPECODE")
#endif
#ifdef __C128__
#pragma code-name (push, "APPCODE")
#endif


void eatwhitei (void)
{while (Input[CurPos]==32) ++CurPos;}

#ifdef __PLUS4__
#pragma code-name (pop)
#endif

//Second part of player init routine.  To be stored in a stub.
void InitPlayer2 (void)
{
	for (i=8; i;) {--i; Player.Inv[i]=Player.ExitRoom=-1;}
	//Player.ExitRoom=-1;
	//Player.Money	=2000;
	memcpy (&Player.RoomInv, &DefRoomItems, (NumItems<<3));
	CRoom=0;
}
#ifdef __ATARI__
#pragma code-name (pop)
#endif
#ifdef __C128__
#pragma code-name (pop)
#endif


//Loads stubs and sets up the player data.
void InitPlayer (void)
{
#ifdef __C64__
	prints ("Loading data...");
	load2 ();
	load2 ();
	load2 ();
#ifdef __USEFARMEM__
	hideloadfile2();
#endif
	printscr ("Done!\n"//);
#elif defined __C128__
	prints ("Loading data...");
	//cbm_k_setbnk (0, 0);
	__asm__ (
		"\tldx\t#0\n"
		"\tstx\ttmp4\n"
		"\tlda\t#$68\n"
		"\tjsr\tcallkernal\n"
		);
	load2 ();
	load2 ();
#ifdef __USEFARMEM__
	bank1_cbm_load ("bank1stub", 8, 0);
#endif
	printscr ("Done!\n"//);
#elif defined __PLUS4__
	prints ("Loading data...");
	load2 ();
	load2 ();
	load2 ();
	load2 ();
	printscr ("Done!\n"//);
#elif defined __ATARI__
	prints ("Loading data...");
	cio_load (1, "D1:TAP.BIN", 0x3FD, 0x303);
	cio_load (1, "D1:MEMX1.BIN", 0x15A4, 0x442);
#ifdef __USEFARMEM__
	loadauxmem ("D1:AUX1.BIN");
#endif
	printscr ("Done!\n"//);
#endif

	//memset (&Player, 0, sizeof(Player));
	/*printscr(*/"What is your name?  (No more\n"
		 "than 15 characters)?");
	GetInput (Player.Name, 15);
	//Player.ExitRoom	=-1;
	//memset (Player.Inv, Player.ExitRoom=-1, 8);
	InitPlayer2 ();
}
//#pragma bss-name (pop)

#ifdef __C128__
#pragma code-name (push, "APPCODE")
#elif defined __C64__
#pragma code-name (push, "TAPECODE")
#elif defined __PLUS4__
#pragma code-name (push, "TAPECODE")
#elif defined __ATARI__
#pragma code-name (push, "TBUFCODE")
#endif

//Routine to get user input.
#ifdef __CBM__
unsigned char __fastcall__ GetInput (char* In, unsigned char InLen)
{
	CurPos=0;
	printc ('>');
	while (1)
	{
		printc ('_');
		i = getkey ();
		printc (20);
		if (i==13){ /*return*/
			In[CurPos]=0;
			printcr ();
			return CurPos;
		} if (i == 20 && CurPos) { /* delete */
			--CurPos;
			printc (20);
		} if ((i&0x60) && CurPos<InLen) {
			In[CurPos]=i;
			printc (i);
			++CurPos;
		}
	}
}
#else
unsigned char __fastcall__ GetInput (char* In, unsigned char InLen)
{
	CurPos=0;
	printc ('>');
	while (1)
	{
		printc ('_');
		i = getkey ();
		printc (CH_DEL);
		if (i==CH_ENTER){ /*return*/
			In[CurPos]=0;
			printcr ();
			return CurPos;
		} if (i == CH_DEL && CurPos) { /* delete */
			--CurPos;
			printc (CH_DEL);
		} else if ((i&0x60)/*isprint(i)*/ && CurPos<InLen) {
			In[CurPos]=i;
			printc (i);
			++CurPos;
		}
	}
}

#endif
#pragma code-name (pop)

#ifdef __C128__
#pragma code-name (push, "APPCODE")
#elif defined __ATARI__
#pragma code-name (push, "MBUFCODE")
#endif

//Displays current room name and score at top of screen.
void DispScoreBoard ()
{
/* Display status */
#ifdef __CBM__
#if defined __PLUS4__ || defined __C128__
	c=wherey();
#else
	c=taby;
#endif
	printc (0x13);
	reverson();
#ifdef __C128__
	for (i=79; i; --i) printc (32);
#ifdef __USEFARMEM__
	prints ("\x13Room: "); printh (hidereadw((void*)&CRm->Name));
	gotox (69); prints ("Score "); printu (Player.Score); printcr ();
#else
	prints ("\x13Room: "); prints (Room[CRoom].Name);
	gotox (69); prints ("Score "); printu (Player.Score); printcr ();
#endif
#else
	for (i=39; i; --i) printc (32);
#ifdef __USEFARMEM__
	prints ("\x13Room: "); printh (hidereadw((void*)&CRm->Name));
	tabx=29; prints ("Score "); printu (Player.Score); printcr ();
#else
	prints ("\x13Room: "); prints (CRm->Name);
	tabx=29; prints ("Score "); printu (Player.Score); printcr ();
#endif
#endif
	gotoy (c);
#elif defined __ATARI__
	c=wherey();
	gotoxy (0, 0);
	for (i=39; i; --i) printc (32|128);
tabx=0;
#ifdef __USEFARMEM__
	printrs ("Room: "); printh (hidereadw((void*)&CRm->Name));
	tabx=29; printrs ("Score "); printu (Player.Score); printcr ();
#else
	printrs ("Room: "); printrs (CRm->Name);
	tabx=29; printrs ("Score "); printu (Player.Score); printcr ();
#endif
	gotoy (c);
#else
#ifdef __USEFARMEM__
	prints ("\x13Room: "); printh (hidereadw((void*)&CRm->Name));
	tabx=29; prints ("Score "); printu (Player.Score); printcr ();
#else
	prints ("\x13Room: "); prints (CRm->Name);
	tabx=29; prints ("Score "); printu (Player.Score); printcr ();
#endif
	gotoy (c);
#endif
}
#pragma bss-name (pop)

#if defined (__ATARI__) || defined (__C128__)
#pragma code-name (pop)
#endif

void main (void)
{
	static void (* vfunc) ();
#ifdef __C128__
	//On a C128, prompt user to switch monitor mode and
	//switch to 80-column mode.
	printscr ("Please switch to 80-column mode now.");
	videomode (VIDEOMODE_80COL);
	bgcolor (1);
#elif defined __C64__
	brdrcol=8;
	backcol=1;
#endif
	//Display start-up banner.
#ifdef __CBM__
	printscr("\f\n\x9cWelcome to \"Adventures on Planet Smir\n"
		 "III, Episode 1, v .10\" for the Commo-\n"
		 "dore 64 and emulators, created with cc65"
		 "by Joseph Rose.\n\n"

		 "Type INTRO during the game for\n"
		 "instructions.\n\n"
		 "Do you want to load a saved game?");
#else
	clrscr ();
	printscr("Welcome to \"Adventures on Planet Smir\n"
		 "III, Episode 1, v .10\" for the Commo-\n"
		 "dore 64 and emulators, created with cc65"
		 "by Joseph Rose.\n\n"

		 "Type INTRO during the game for\n"
		 "instructions.\n\n"
		 "Do you want to load a saved game?");
#endif
	c=0;
	switch (getkey ())
	{
	case 'd': ++c;		//Debug mode: start in specified room #.
	case 'y': ++c;		//Load saved game.
	}
	InitPlayer ();
	//Put game load code here at option c==1.
	
	//If debug mode, get start room # and switch to room.
	if (c==2) {
		printscr ("Debug mode: Enter room #"); GetInput (Input, 4);
		for (CurPos=0;Input[CurPos]; ++CurPos)
		{
			CRoom=(((CRoom<<2)+CRoom)<<1)+(Input[CurPos]&0xF);
		}
	}
	//Display default room.
	vLook2 ();
	//Main loop.
	while (1)
	{
		DispScoreBoard();
		if (!GetInput (&Input,38)) continue;
		Vrb = FindVerb (/*Input*/);
		if ((signed char)Vrb<0) {
			prints ("I don't know how to ");
			prints (Input); 
			printperiod ();
			continue;
		}
			eatwhitei ();
			Itm1=0xFF;
			if (Input[CurPos])
			{
				if ((Itm1 = FindItem ())==0xFF ) {
					prints ("I don't know what a ");
					prints (&Input[CurPos]);
					printscr (" is.");
					continue;
				} ItemPtr=&Item[Itm1];
//printu (Itm1); printcr();
			}
			
runverb:
#if defined __USEFARMEM__ && !defined __C128__
			vfunc=hidereadw((void*)&Verb[Vrb].vdo);
#else
			vfunc=Verb[Vrb].vdo;
#endif
			(*vfunc) ();
		//}
	}
}

