#ifndef __adv_words_H
#define __adv_words_H

#include "aconst.h"
/****************************************************
 *
 *	 Defines structs to hold verbs, nouns and
 *	 special data related to some objects.
 *
 ****************************************************/

extern unsigned char Itm1;
#pragma zpsym ("Itm1")

typedef struct verb_
{
	unsigned char* Name;
	void (*vdo) (/*char itm1*/);
		/* Routine to perform action */
};

extern struct verb_ Verb [NumVerbs];


unsigned char FindVerb (/*char* Input*/);

typedef struct item_
{
	unsigned char* Name;
	unsigned char Attrib;
	unsigned char *Info;
	unsigned char x;
};
extern struct item_ Item [NumItems], *ItemPtr;
#pragma zpsym ("ItemPtr")

typedef struct item_Alias
{
	unsigned char* Name;
	char Num;
};
extern struct item_Alias ItemAlias [NumItemAliases];

typedef struct ItemCate
{
	char* Name;
	char Items[6];
};
extern struct ItemCate ItemCate [NumItemCate];

typedef struct ItemEnv
{
	char Item, t;
	unsigned short State;
};

unsigned char __fastcall__ FindItem ();
//char __fastcall__ GetCateItem (char* Itm1, char* Inv);

/* item state: */
#define itemSOpen	0x0001
	/*True if open, false if closed.*/
#define itemSOn 	0x0001
	/*True if on, false if off.*/
#define itemSLocked	0x0002
	/*True if locked.*/
#define itemSSpecState	0xFF00
	/*Dependent on item.*/
#define itemSRead	0x0004

/* item attributes: */
#define itemAMovable	0x01
	/*If true, can be picked up, moved, given, etc.*/
#define itemAStateChangable 0x02
	/*If true, can be open, closed and changed.*/

unsigned char __fastcall__ iSearch (unsigned char* i);

/****************************************************
   Item Numbers
 ****************************************************/

#define iKey		  0

/* Partial Items/Categories */
#define iMap_		128

/* Special */
#define iNorth		160
#define iSouth		161
#define iEast		162
#define iWest		163

/* People srart at 192 */

/****************************************************
   General verb-handlers
 ****************************************************/

void vLook	(void);
void vGo	(void);
void vItems	(void); /* Inventory */
void vBuy	(void);

void vTeleport	(void);
void vExit	(void);
void vEnter	(void);

void vSay	(void);
void vAnswer	(void);


void vGet	(void);
void vPut	(void);
void vRead	(void);


void vIntro	(void);
void vHelp	(void);

void vGoNorth	(void);
void vGoSouth	(void);
void vGoEast	(void);
void vGoWest	(void);

/*
void vPut	(char Itm1);
void vOpen	(char Itm1);
void vClose	(char Itm1);
void vEnter	(char Itm1);
void vExit	(char Itm1);
void vLock	(char Itm1);
void vUnlock	(char Itm1);
void vAsk	(char Itm1);
void vCall	(char Itm1);
void vRead	(char Itm1);
*/

extern const unsigned char* DirecPart [3];

/****************************************************
   Message Numbers
 ****************************************************/
extern const char* Message [];
#define msgDontHave 		  0
#define msgHoldingTooManyItems	  1
#define msgTooManyItemsInRoom	  2
#define msgAlreadyHave		  3
#define msgCantGoThere		  4
#define msgItemNotAvail		  5
#define msgBeMoreSpec		  6

/****************************************************
   Inventory
 ****************************************************/

unsigned char __fastcall__ SearchInv (unsigned char* Inv, unsigned char Itm);
unsigned char __fastcall__ AddInv (unsigned char* Inv);
unsigned char __fastcall__ RemoveInv (unsigned char* Inv);


/****************************************************
   Object-specific data
 ****************************************************/



/*	Phones	*/
/************/
typedef struct Phone
{
	char State;
};


extern const struct Phone Phone[NumPhones];
typedef struct PhoneNum_
{
	char Code[6];
	void (*Answerer) (void);
};
extern const struct PhoneNum_ PhoneNum[NumPhones];
extern unsigned char GetCall;

void vAnswerPhone (void);  /* Answer the phone. */
void vReadPhoneBook (void);




/************************************
	Items to buy
 ************************************/

typedef struct BuyItems
{
	char Num;
	char t;
	unsigned short Price;
};

extern const struct BuyItems *BuyItems [NumStores];


/************************************
	People
 ************************************/

typedef struct person_
{
	char* Name;
	void (*Ask) (char* Q);		/* Ask a question */
	void (*Say) (char* c);		/* Talk */
	void (*Give) (char Itm);	/* Give something */
};
extern const struct person_ Person [NumPersons];

#define pTalnon 	  0
#define pMalgon 	  1

void DescribePortalToMalin(void);

#endif

