/**************************************************
 *
 *   Contains the vocabulary and responses of
 *   Adventures on Planet Smir III, 1
 *
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <errno.h>
#include <ctype.h>

#include "aconst.h"
#include "words.h"
#include "stores.h"
#include "rooms.h"
#include "player.h"
#include "input.h"

#include "c64hide.h"
/*************************************
	Items
 *************************************/

#ifdef __USEFARMEM__
#ifdef __C128__
#pragma data-name ("B1DATA")
#pragma rodata-name ("B1RODATA")
#elif defined __C64__
#pragma data-name ("HIDEDATA")
#pragma rodata-name ("HIDECONST")
#elif defined __ATARIXL__
#pragma data-name ("AUXDATA")
#pragma rodata-name ("AUXRO")
#endif
#endif

#pragma local-strings (on)
#ifdef __C128__
#pragma data-name ("TAPEDATA")
#pragma rodata-name ("BSTACKCODE")
#endif

//Nouns:
struct item_ Item []={
	/*1234567890123456*/
/* Item 0 */
	{"key",
		itemAStateChangable | itemAMovable,
		"Description of key."}
};

//Item categories.
//For each entry, start with the name, then continue with up to 6 items
//in the form of the item's #.  If <6 items, end with -1.
struct ItemCate ItemCate []=
{
	{"map",
		{-1}},
};

//Synonyms for other items.
//Start each entry with the name, then follow with the item #.
struct item_Alias ItemAlias []=
{
};

//Vaerbs.  Each entry starts with the name then adds the address of the
//verb handler.
#if defined __C128__
#pragma rodata-name ("TAPECODE")
#endif
struct verb_ Verb[] ={
	{"look",	&vLook},
	{"go",		&vGo},
	//{"teleport",	&vTeleport},
	{"enter",	&vEnter},
	{"exit",	&vExit},

	{"say",		&vSay},
	{"talk",	&vSay},
	{"answer",	&vAnswer},

	{"get",		&vGet},
	{"grab",	&vGet},
	{"take",	&vGet},
	{"put",		&vPut},
	{"place",	&vPut},
	{"drop",	&vPut},
	{"inventory",	&vItems},
	{"i",		&vItems},
	//{"buy",		&vBuy},

	{"intro",	&vIntro},
	{"help",	&vHelp},
	{"read",	&vRead},

	{"n",		&vGoNorth},
	{"s",		&vGoSouth},
	{"e",		&vGoEast},
	{"w",		&vGoWest}
/*	{"ask",		&vAsk},
	{"put",		&vPut},

	{"open",	&vOpen},
	{"close",	&vClose},

	{"exit",	&vExit},

	{"lock",	&vLock},
	{"unlock",	&vUnlock},

	{"ask",		&vAsk},
	{"call",	&vCall},

	{"read",	&vRead}*/
};

//Instructions on how to play the game.
//Displayed when the user types "intro."
//Currently only supports two pages.  If you
//want more, add to the vIntro() function in
//Words.c.
char* HelpPages[2] =
{
	// "\f\nThe object of this game is to find your\n"
	// "friend Talnon, all who were kidnapped\n"
	// "and all stolen property.  I will tell no"
	// "more about the object of this game.  To\n"
	// "play, you type in commands on your\n"
	// "computer or emulator.  Such commands\n"
	// "include:\n"
	// "\n"
	// "get/put <object>   inventory (or i)\n"
	// "go <dir>           exit\n"
	// "look [<item>]      read <item>\n"
	// "\n"
	// "Some rooms (i.e. teleporters) require\n"
	// "you to type \"enter <room>\" to enter\n"
	// "them.\n"
	// "\nPress Return to continue or x to return\n"
	// "to game.\n"
	"\f\nPlace instruction page 1 here.\n\n"
	"Press X to exit or "
,
	// "\f\nSpecial commands are also available:\n"
	// "\n"
	// "enter <room type> to enter teleporters &"
	// "      phone booths\n"
	// "answer <person>     buy <item> in stores"
	// "save/load           quit\n"
	// "say/talk to <person>exit\n"
	// "teleport            call\n"
	// "\n"
	// "Special hints:\n"
	// "*  Use maps.  They're not worth points,\n"
	// "   but are sprinkled throughout the game"
	// "   and can help you navigate through the"
	// "   game.\n"
	// "*  Scanners allow you to detect nearby\n"
	// "   objects.  Just type scan <object>.\n"
	// "   You can have multiple scanners.\n"
	"\f\nPlace instruction page 2 here.\n\n"

};

#if defined __C128__ && !defined __USEFARMEM__
//#pragma rodata-name (pop)
#endif
