;
; Ullrich von Bassewitz, 15.09.2000
;
; int memcmp (const void* p1, const void* p2, size_t count);
;

        .export         _bank1_memcmpin, _bank1_memcmpto

	.export		b1_memcmpbytein, b1_memcmpbytefrom, b1_memcmpbyteto

        .import         popax, return0
        .importzp       ptr1, ptr2, ptr3, regbank

	.import		bank1_readbyteoffs2, bank1_writebytedirect

	
_bank1_memcmpin:
	pha
	lda	#$4C
	sta	regbank
	lda	#<b1_memcmpbytein
	sta	regbank+1
	lda	#>b1_memcmpbytein
	sta	regbank+2
	pla
	bne	b1_memcmp
_bank1_memcmpto:
	pha
	lda	#$4C
	sta	regbank
	lda	#<b1_memcmpbyteto
	sta	regbank+1
	lda	#>b1_memcmpbyteto
	sta	regbank+2
	pla
	;bne	b1_memcmp
b1_memcmp:

; Calculate (-count-1) and store it into ptr3. This is some overhead here but
; saves time in the compare loop

        eor     #$FF
        sta     ptr3
        txa
        eor     #$FF
        sta     ptr3+1

; Get the pointer parameters

        jsr     popax           ; Get p2
        sta     ptr2
        stx     ptr2+1
        jsr     popax           ; Get p1
        sta     ptr1
        stx     ptr1+1

; Loop initialization

        ldx     ptr3            ; Load low counter byte into X
        ldy     #$00            ; Initialize pointer

; Head of compare loop: Test for the end condition

Loop:   inx                     ; Bump low byte of (-count-1)
        beq     BumpHiCnt       ; Jump on overflow

; Do the compare

Comp:   
	;lda     (ptr1),y
        ;cmp     (ptr2),y
	jsr	regbank
        bne     NotEqual        ; Jump if bytes not equal

; Bump the pointers

        iny                     ; Increment pointer
        bne     Loop
        inc     ptr1+1          ; Increment high bytes
        inc     ptr2+1
        bne     Loop            ; Branch always (pointer wrap is illegal)

; Entry on low counter byte overflow

BumpHiCnt:
        inc     ptr3+1          ; Bump high byte of (-count-1)
        bne     Comp            ; Jump if not done
        jmp     return0         ; Count is zero, areas are identical

; Not equal, check which one is greater

NotEqual:
        bcs     Greater
        ldx     #$FF            ; Make result negative
        rts

Greater:
        ldx     #$01            ; Make result positive
        rts

.segment	"BANK1C"
b1_memcmpbytein:
	sta	$FF02
	lda	(ptr1),y
	cmp	(ptr2),y
	sta	$FF01
	rts

b1_memcmpbytefrom:
	sta	$FF02
	lda	(ptr1),y
	sta	$FF01
	cmp	(ptr2),y
	rts

b1_memcmpbyteto:
	lda	(ptr1),y
	cmp	(ptr2),y
	sta	$FF01
	rts
